uniform float darkness = 0.75;
uniform float dist = 1;
uniform float x_step = 1;
uniform float y_step = 1;

vec4 effect(vec4 vcolor, Image texture, vec2 coord, vec2 pixel_coords) {
	vec4 orig = Texel(texture, coord);

	if (orig.a < darkness) {
		float alpha = 0.0;

		for (float i=y_step; i<dist; i+=y_step) {
			coord.x += x_step;
			coord.y -= y_step;

			vec4 pix = Texel(texture, coord);

			float pixdark = pix.a * pow(1-i/dist, 1.25);

			if (pixdark > alpha) alpha = pixdark;
		}

		if (orig.a < alpha*darkness) {
			return vec4(orig.xyz * (orig.a / (alpha*darkness)), alpha*darkness);
		}
		else return orig;
	}
	else return orig;
}
