local love = love
local math = math

window = {
	w = 640, h = 360, sM = 1,
	vw = 640, vh = 360, s = 1
}
local window = window

-- Making sure to keep the correct dimensions without constant calls
function love.resize(w, h)
	local s = math.max(1, math.round(((w*h)/(640*360))^0.5  * window.sM))

	window.w = w
	window.h = h
	window.s = s
	window.vw = w / s
	window.vh = h / s

	jnr.resize(w, h)
end

-- Losing/Gaining Focus
local windowTitle
local mouseVisible = false
function love.focus(focus)
	if focus then
		if windowTitle then
			love.window.setTitle(windowTitle)
		end

		love.mouse.setVisible(mouseVisible)
	else
		windowTitle = love.window.getTitle()
		love.window.setTitle("DPlox Parkour 2  ––  Left alone running in the background... ;-;")

		mouseVisible = love.mouse.isVisible()
		love.mouse.setVisible(true)
	end
end

function love.quit()
	if game then
		-- Saving the game when the process is exited... No easy cheating.
		if game.state == jnr or (game.state == menu and menu.substate == "pause") then
			save.write()
		end

		-- Saving a replay, if one is being recorded...
		if input.record.state == "recording" then
			if not love.filesystem.isDirectory("replay") then love.filesystem.createDirectory("replay") end
			input.record.finish(saveLib.write, "replay/"..os.date("%y-%m-%d_%H.%M.%S")..".bin")
		end
	end
end
