local window = window

local Entity = {}
local Object = require("jnr.object")

function Entity:new(x, y, z, data, ...)
	self:__new(x, y, data.w or 9, data.h or 9, z or 0)

	self.preAcc  = data.preAcc
	self.postAcc = data.postAcc
	self.postCol = data.postCol
	self.draw    = data.draw
	self.hasColided = data.hasColided

	self.hurt  = data.hurt
	self.kill  = data.kill
	self.reset = data.reset
	self.init  = data.init

	self.id = data.id
	self.mass = data.mass or self.mass

	self.effects = data.effects

	if data.new then data.new(self, ...) end

	self.__data = data
end

Entity.preAcc = Object.setAcceleration

function Entity:update(dt)
	self:preAcc(dt)
	self:accelerate(dt)
	self:postAcc(dt)
	self:colide(dt)
	self:postCol(dt)

	if self.y > self.tiles.height * self.tiles.ts + window.vh * 0.5 then
		self:kill(true)
	end

	if self.effects then
		self:spawnParticles(dt)
		self:makeSounds()
	end
end

function Entity:postAcc(dt)
	-- Code goes here...
	-- Inputs/AI etc.
end

function Entity:postCol(dt)
	-- Code goes here...
	-- Animation etc.
end

--[[function Entity:kill(depth)
	-- depth is true when the entity fell off-stage.
end]]

Entity.effects = true

function Entity:__tostring()
	return ("Entity (%s): Pos. %.2f, %.2f"):format(self.id or "unknown", self.x or 0/0, self.y or 0/0)
end

return class("Entity", Object, Entity)
