local roundn = math.roundn

local boss1_shock = {
	w = 9, h = 9, mass = 0,
	anim = anim.newHeader(assets.image("assets/entity/boss1_shock.png"), 9, 9)
		:reg(0, 1,1, 4, 15, true)
}

function boss1_shock:new(dir)
	self.xv = dir * 160
	self.xvAcc = 1

	self.canColide = false
	self.floating = true
	self.cooldown = 0.1

	self.anim = boss1_shock.anim:clone():set(0)
end

function boss1_shock:hasColided(other, dir, dt)
	if dir == "n" and (other.type ~= "Entity" or other.id ~= "boss1_shock") and self.cooldown <= 0 then
		self.cooldown = 0.1
		other:hurt(self)

		self.w = self.w - 3
		self.h = self.h - 3
		if self.w <= 0 then
			self:kill()
		else
			self.x = self.x + 1.5
			self.y = self.y + 3
		end
	end
end

function boss1_shock:preAcc() end
function boss1_shock:postAcc(dt)
	if self.cooldown > 0 then
		self.cooldown = self.cooldown - dt
	end
end
function boss1_shock:postCol(dt)
	self.anim:update(dt)
	if self.xv == 0 then
		self:kill()
	end
end

function boss1_shock:draw(s)
	self.anim:draw(roundn(self.x, s), roundn(self.y, s), 0, self.w/9, self.h/9)
end

return boss1_shock
