local roundn = math.roundn
local sfx = sfx

local coin = {
	w = 9, h = 9,
	anim = anim.newHeader(assets.image("assets/object/coin.png"), 9, 9)
		:reg(0, 1, 1, 6, 10, true)
}

function coin:new()
	self.anim = coin.anim:clone():set(0)

	self.xv = random:random()*360-180
	self.yv = random:random()*-210

	self.canColide = false
	self.collected = false
end

function coin:hasColided(other, dir, dt)
	if other.canCollect and not self.collected then
		if not other.dead then
			self.collected = true

			self:kill()
			self.tiles.collect = self.tiles.collect + 1
			sfx.collect:play(self.x+self.w*0.5, self.y+self.h*0.5)
		end
	end
end

function coin:kill(depth)
	if depth then
		self.yv = -1024
	else
		self:remove()
	end
end

function coin:postCol(dt)
	self.anim:update(dt)
end

function coin:draw(s)
	self.anim:draw(roundn(self.x, s), roundn(self.y, s))
end

return coin
