local colors = colors

return {
	label = "Bonus",
	color = colors.new(0, 175, 0),

	{
		text = "Passwords...", desc = "Enter passwords to unlock secret stuff!",
		action = "password"
	},
	-- Needs additional implementations...
	{
		text = "Load DPlox Parkour (1) Data", desc = "Load saved data of the original game to unlock special rewards in this game.\nNOT FULLY IMPLEMENTED! (NOT ALL REWARDS)",
		action = function()
			-- Set to the first game's save directory
			love.filesystem.setIdentity("DPloxParkour", true)

			if love.filesystem.isFile("sav.bin") then
				local s, r = pcall(function()
					local sav_bin = saveLib.read("sav.bin")
					local unlocks = 0
					if sav_bin.levels[ 5] then
						-- 1-Boss
						unlocks = unlocks + 1
						game.message.queue "Killed Boss 1"
					end
					if sav_bin.levels[11] then
						-- 2-Boss
						unlocks = unlocks + 1
						game.message.queue "Killed Boss 2"
					end
					if sav_bin.levels[18] then
						-- 3-Boss
						unlocks = unlocks + 1
						game.message.queue "Killed Boss 3"
					end
					if sav_bin.levels[24] then
						-- 4-Boss
						unlocks = unlocks + 1
						if not save.unlock("siblings", "char") then
							game.message.queue "Already claimed reward for clearing the main game."
						end
					end
					if sav_bin.levels[94] then
						-- HDN-Boss
						unlocks = unlocks + 1
						if not save.unlock("purple_sister", "char") then
							game.message.queue "Already claimed reward for clearing the HDN Area."
						end
					end
					if sav_bin.collect >= 708 then
						-- Max. Collect
						unlocks = unlocks + 1
						game.message.queue "All Collectibles"
					end
					if sav_bin.endlessScore >= 1000 then
						-- Endless Score (It's over 1k!)
						unlocks = unlocks + 1
						game.message.queue "1k endless score"
					end
					if unlocks == 0 then
						game.message.queue{
							colors.white, "Doesn't seem like there's anything you are ",
							colors.yellow, "worthy",
							colors.white, " to receive."
						}
					elseif unlocks >= 7 then
						game.message.queue{
							colors.white, "Wow! You did absolutely ",
							colors.yellow, "everything",
							colors.white, ".\nYou're great!"
						}
					end
				end)
				if not s then
					print(r)
					game.message.queue{colors.red, "Something is wrong with that save data (sav.bin)..."}
				end
			else
				game.message.queue("Could not find any DPlox Parkour 1 save data (sav.bin)...")
			end

			if love.filesystem.isFile("unl.bin") then
				local s, r = pcall(function()
					local unl_bin = saveLib.read("unl.bin")
				end)
				if not s then
					print(r)
					game.message.queue{colors.red, "Something is wrong with that unlock data (unl.bin)..."}
				end
			else
				game.message.queue("Could not find any DPlox Parkour 1 unlock data (unl.bin)...")
			end

			-- Return to correct save directory
			love.filesystem.setIdentity(_gameIdentity, true)
		end
	},
	false,
	{
		text = "Secrets", desc = "It's a secret to everybody...!",
		action = "secrets"
	},
	false,
	{
		text = "Back", action = "!"
	}
}
