local tostring = tostring
local insert = table.insert
local colors = colors

local data = {
	label = "Credits (Music)",
	cancel = true,

	false,
	{
		text = "Back", action = "!"
	}
}

local all = {}
for k,v in pairs(music) do
	if k ~= "current" and k ~= "set" then
		all[#all+1] = v
	end
end

table.sort(all, function(a,b)
	if a.author ~= b.author then
		return tostring(a.author) > tostring(b.author)
	else
		return tostring(a.full_title) > tostring(b.full_title)
	end
end)

for i,v in ipairs(all) do
	insert(data, 1, {
		text = {
			colors.yelora, "[>] ",
			colors.white, v.full_title or "No title",
		},
		desc = {
			colors.white, v.full_title or "Track",
			colors.softBlue, "\nby ",
			colors.white, v.author or "unknown",
			colors.blue, "\n["..(v.link or "No link").."]\n",
			colors.softBlue, v.credits or ""
		},
		action = function(self)
			if v.link then
				love.system.openURL(v.link)
			end
		end,
		actionR = function(self)
			music.set(v.id)
		end
	})
end

if #data == 2 then
	insert(data, 1, { text = "---" })
end

return data
