local love = love

local assigned = {}
for i,v in pairs{"kl", "kr", "ku", "kd", "kj", "ka", "kp", "kc"} do
	assigned[cnf[v]] = true
end

local function setKey(name, bind, cnfId)
	return {
		text = {
			colors.white, name.."> ",
			colors.yelora, "[ ",
			colors.white, input.getKeyName(cnf[cnfId]),
			colors.yelora, " ]"
		},
		action = function(self)
			self.origText = self.text
			self.text = "Hit new key for '"..name.."'"
			local keypressed = love.keypressed
			local keyreleased = love.keyreleased
			local gamepadpressed = love.gamepadpressed
			local gamepadreleased = love.gamepadreleased
			local gamepadaxis = love.gamepadaxis

			input.bindKey(cnf[cnfId], nil)
			assigned[cnf[cnfId]] = nil

			function love.keypressed(key, scancode, isrepeat)
				if not (scancode:find("^f[0-9]") or assigned[scancode]) then
					input.bindKey(scancode, bind)
					cnf[cnfId] = scancode
					assigned[scancode] = true

					love.keypressed = keypressed
					love.keyreleased = keyreleased
					love.gamepadpressed = gamepadpressed
					love.gamepadreleased = gamepadreleased
					love.gamepadaxis = gamepadaxis

					self.text = self.origText
					self.text[6] = input.getKeyName(scancode)
				end
			end

			local function empty() end
			love.keyreleased = empty
			love.gamepadpressed = empty
			love.gamepadreleased = empty
			love.gamepadaxis = empty
		end
	}
end

return {
	label = "Keyboard Setup",
	color = colors.new(200, 100, 0),
	thin = true,

	setKey("Left", "left", "kl"),
	setKey("Right", "right", "kr"),
	setKey("Up", "up", "ku"),
	setKey("Down", "down", "kd"),
	setKey("Jump/Accept", "jump", "kj"),
	setKey("Attack/Cancel", "attack", "ka"),
	setKey("Pause", "pause", "kp"),
	setKey("Char. Sel.", "cselect", "kc"),
	false,
	{
		text = "Back", action = "!"
	}
}
