local colors = colors

local data = {
	label = "Secrets",
	color = colors.new(0, 175, 0),

	false,
	{
		text = "Back", action = "!"
	}
}

local secrets = fileT.load("menu/data/secrets/#names.txt")
local secretList = {}
for k,v in pairs(secrets) do
	if unlocks[k] then
		secretList[#secretList+1] = {
			text = v, index = k,
			action = function()
				local this = _secrets[k]
				if this == nil then
					this = require("menu.data.secrets."..k)
					if type(this) == "function" then
						this()
					else
						game.message.queue{
							colors.yellow, v,
							colors.white, "\nPlease restart the game to reset the effects of this secret."
						}
					end
					_secrets[k] = this
				elseif type(this) == "function" then
					this()
				else
					game.message.queue "Already active!"
				end
			end
		}
	end
end

if #secretList > 0 then
	table.sort(secretList, function(a, b)
		return a.index > b.index
	end)

	local insert = table.insert
	for i=1, #secretList do
		insert(data, 1, secretList[i])
	end
else
	table.insert(data, 1, {
		text = "No secrets discovered!", desc = "Maybe you should try harder!"
	})
end

return data
